<?xml version="1.0" encoding="UTF-8" ?>
<!DOCTYPE mapper
PUBLIC "-//mybatis.org//DTD Mapper 3.0//EN"
"http://mybatis.org/dtd/mybatis-3-mapper.dtd">
<mapper namespace="com.yanzhu.manage.mapper.ProProjectInfoDeptsMapper">
    
    <resultMap type="ProProjectInfoDepts" id="ProProjectInfoDeptsResult">
        <result property="id"    column="id"    />
        <result property="projectId"    column="project_id"    />
        <result property="projectName"    column="project_name"    />
        <result property="deptType"    column="dept_type"    />
        <result property="deptName"    column="dept_name"    />
        <result property="deptCode"    column="dept_code"    />
        <result property="leader"    column="leader"    />
        <result property="phone"    column="phone"    />
        <result property="isDel"    column="is_del"    />
        <result property="createBy"    column="create_by"    />
        <result property="createTime"    column="create_time"    />
        <result property="updateBy"    column="update_by"    />
        <result property="updateTime"    column="update_time"    />
        <result property="remark"    column="remark"    />
    </resultMap>

    <sql id="selectProProjectInfoDeptsVo">
        select pd.id, pd.project_id, pi.project_name, pd.dept_type, pd.dept_name, pd.dept_code, pd.leader, pd.phone, pd.is_del, pd.create_by, pd.create_time, pd.update_by, pd.update_time, pd.remark
        from pro_project_info_depts pd
        left join pro_project_info pi on pi.id = pd.project_id
        left join sys_dept sd on sd.dept_id = pi.com_id
    </sql>

    <select id="selectProProjectInfoDeptsList" parameterType="ProProjectInfoDepts" resultMap="ProProjectInfoDeptsResult">
        <include refid="selectProProjectInfoDeptsVo"/>
        <where>
            <if test="activeComId != null "> and sd.dept_id = #{activeComId}</if>
            <if test="projectId != null "> and pd.project_id = #{projectId}</if>
            <if test="projectName != null  and projectName != ''"> and pi.project_name like concat('%', #{projectName}, '%')</if>
            <if test="deptType != null  and deptType != ''"> and pd.dept_type = #{deptType}</if>
            <if test="deptName != null  and deptName != ''"> and pd.dept_name like concat('%', #{deptName}, '%')</if>
            <if test="deptCode != null  and deptCode != ''"> and pd.dept_code = #{deptCode}</if>
            <if test="isDel != null "> and pd.is_del = #{isDel}</if>
        </where>
    </select>
    
    <select id="selectProProjectInfoDeptsById" parameterType="Long" resultMap="ProProjectInfoDeptsResult">
        <include refid="selectProProjectInfoDeptsVo"/>
        where pd.id = #{id}
    </select>
        
    <insert id="insertProProjectInfoDepts" parameterType="ProProjectInfoDepts" useGeneratedKeys="true" keyProperty="id">
        insert into pro_project_info_depts
        <trim prefix="(" suffix=")" suffixOverrides=",">
            <if test="projectId != null">project_id,</if>
            <if test="deptType != null">dept_type,</if>
            <if test="deptName != null">dept_name,</if>
            <if test="deptCode != null">dept_code,</if>
            <if test="leader != null">leader,</if>
            <if test="phone != null">phone,</if>
            <if test="isDel != null">is_del,</if>
            <if test="createBy != null">create_by,</if>
            <if test="createTime != null">create_time,</if>
            <if test="updateBy != null">update_by,</if>
            <if test="updateTime != null">update_time,</if>
            <if test="remark != null">remark,</if>
         </trim>
        <trim prefix="values (" suffix=")" suffixOverrides=",">
            <if test="projectId != null">#{projectId},</if>
            <if test="deptType != null">#{deptType},</if>
            <if test="deptName != null">#{deptName},</if>
            <if test="deptCode != null">#{deptCode},</if>
            <if test="leader != null">#{leader},</if>
            <if test="phone != null">#{phone},</if>
            <if test="isDel != null">#{isDel},</if>
            <if test="createBy != null">#{createBy},</if>
            <if test="createTime != null">#{createTime},</if>
            <if test="updateBy != null">#{updateBy},</if>
            <if test="updateTime != null">#{updateTime},</if>
            <if test="remark != null">#{remark},</if>
         </trim>
    </insert>

    <update id="updateProProjectInfoDepts" parameterType="ProProjectInfoDepts">
        update pro_project_info_depts
        <trim prefix="SET" suffixOverrides=",">
            <if test="projectId != null">project_id = #{projectId},</if>
            <if test="deptType != null">dept_type = #{deptType},</if>
            <if test="deptName != null">dept_name = #{deptName},</if>
            <if test="deptCode != null">dept_code = #{deptCode},</if>
            <if test="leader != null">leader = #{leader},</if>
            <if test="phone != null">phone = #{phone},</if>
            <if test="isDel != null">is_del = #{isDel},</if>
            <if test="createBy != null">create_by = #{createBy},</if>
            <if test="createTime != null">create_time = #{createTime},</if>
            <if test="updateBy != null">update_by = #{updateBy},</if>
            <if test="updateTime != null">update_time = #{updateTime},</if>
            <if test="remark != null">remark = #{remark},</if>
        </trim>
        where id = #{id}
    </update>

    <delete id="deleteProProjectInfoDeptsById" parameterType="Long">
        delete from pro_project_info_depts where id = #{id}
    </delete>

    <delete id="deleteProProjectInfoDeptsByIds" parameterType="String">
        delete from pro_project_info_depts where id in 
        <foreach item="id" collection="array" open="(" separator="," close=")">
            #{id}
        </foreach>
    </delete>
</mapper>